"use strict";

exports.__esModule = true;
exports.default = getPointerType;

/**
 * Copyright (c) Nicolas Gallagher.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 * 
 */
function getPointerType(nativeEvent) {
  var _ref = nativeEvent,
      changedTouches = _ref.changedTouches,
      pointerType = _ref.pointerType,
      type = _ref.type;
  var eventPointerType = '';

  if (pointerType !== undefined) {
    eventPointerType = pointerType;
  } else if (changedTouches !== undefined) {
    eventPointerType = 'touch';
  } else if (type === 'mousedown' || type === 'mouseenter' || type === 'mouseleave' || type === 'mousemove' || type === 'mouseout' || type === 'mouseover' || type === 'mouseup') {
    eventPointerType = 'mouse';
  }

  return eventPointerType;
}

module.exports = exports.default;