"use strict";

exports.__esModule = true;
exports.default = hyphenateStyleName;

/**
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 * 
 */
var uppercasePattern = /[A-Z]/g;
var msPattern = /^ms-/;
var cache = {};

function toHyphenLower(match) {
  return '-' + match.toLowerCase();
}

function hyphenateStyleName(name) {
  if (cache.hasOwnProperty(name)) {
    return cache[name];
  }

  var hyphenatedName = name.replace(uppercasePattern, toHyphenLower);
  var result = msPattern.test(hyphenatedName) ? '-' + hyphenatedName : hyphenatedName;
  cache[name] = result;
  return result;
}

module.exports = exports.default;