/**
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 * 
 */
'use strict';

exports.__esModule = true;
exports.default = supportsFocusOptions;

var _supportsDOM = _interopRequireDefault(require("../__modules__/supportsDOM"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var canUseDOM = (0, _supportsDOM.default)();

function supportsFocusOptions() {
  var supported = false; // Check if browser supports focus with options

  if (canUseDOM) {
    try {
      var element = document.createElement('div');
      var options = {};
      Object.defineProperty(options, 'preventScroll', {
        get: function get() {
          supported = true;
          return false;
        }
      });
      element.focus(options);
    } catch (e) {}
  }

  return supported;
}

module.exports = exports.default;