"use strict";

exports.__esModule = true;
exports.default = useMediaQuery;

var React = _interopRequireWildcard(require("react"));

var _supportsDOM = _interopRequireDefault(require("./supportsDOM"));

var _useLayoutEffect = _interopRequireDefault(require("./useLayoutEffect"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Copyright (c) Nicolas Gallagher.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 * 
 */
function useMediaQuery(query) {
  var _React$useState = React.useState(false),
      state = _React$useState[0],
      setState = _React$useState[1];

  (0, _useLayoutEffect.default)(function () {
    if ((0, _supportsDOM.default)()) {
      var mediaQueryList = window.matchMedia(query);

      var listener = function listener() {
        setState(Boolean(mediaQueryList.matches));
      };

      mediaQueryList.addListener(listener);
      setState(mediaQueryList.matches);
      return function () {
        mediaQueryList.removeListener(listener);
      };
    }
  }, [query]);
  return state;
}

module.exports = exports.default;