"use strict";

exports.__esModule = true;
exports.filterProps = filterProps;
exports.default = createAccessibilityStyledProps;

var React = _interopRequireWildcard(require("react"));

var _pick = _interopRequireDefault(require("../__modules__/pick"));

var _styleResolver = _interopRequireDefault(require("../style-sheet/styleResolver"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var hasOwnProperty = Object.prototype.hasOwnProperty;
var passList = {
  accessibilityActiveDescendant: true,
  accessibilityAtomic: true,
  accessibilityAutoComplete: true,
  accessibilityBusy: true,
  accessibilityChecked: true,
  accessibilityColumnCount: true,
  accessibilityColumnIndex: true,
  accessibilityColumnSpan: true,
  accessibilityControls: true,
  accessibilityDescribedBy: true,
  accessibilityDetails: true,
  accessibilityDisabled: true,
  accessibilityErrorMessage: true,
  accessibilityExpanded: true,
  accessibilityFlowTo: true,
  accessibilityHasPopup: true,
  accessibilityHidden: true,
  accessibilityInvalid: true,
  accessibilityKeyShortcuts: true,
  accessibilityLabel: true,
  accessibilityLabelledBy: true,
  accessibilityLevel: true,
  accessibilityLiveRegion: true,
  accessibilityModal: true,
  accessibilityMultiline: true,
  accessibilityMultiSelectable: true,
  accessibilityOrientation: true,
  accessibilityOwns: true,
  accessibilityPlaceholder: true,
  accessibilityPosInSet: true,
  accessibilityPressed: true,
  accessibilityReadOnly: true,
  accessibilityRequired: true,
  accessibilityRole: true,
  accessibilityRoleDescription: true,
  accessibilityRowCount: true,
  accessibilityRowIndex: true,
  accessibilityRowSpan: true,
  accessibilitySelected: true,
  accessibilitySetSize: true,
  accessibilitySort: true,
  accessibilityValueMax: true,
  accessibilityValueMin: true,
  accessibilityValueNow: true,
  accessibilityValueText: true,
  children: true,
  focusable: true,
  dataSet: true,
  nativeID: true,
  ref: true,
  style: true,
  testID: true
};

function filterProps(props) {
  return (0, _pick.default)(props, passList);
}

function createAccessibilityStyledProps(componentType, props) {
  if (props == null) {
    return {};
  }

  var accessibilityActiveDescendant = props.accessibilityActiveDescendant,
      accessibilityAtomic = props.accessibilityAtomic,
      accessibilityAutoComplete = props.accessibilityAutoComplete,
      accessibilityBusy = props.accessibilityBusy,
      accessibilityChecked = props.accessibilityChecked,
      accessibilityColumnCount = props.accessibilityColumnCount,
      accessibilityColumnIndex = props.accessibilityColumnIndex,
      accessibilityColumnSpan = props.accessibilityColumnSpan,
      accessibilityControls = props.accessibilityControls,
      accessibilityDescribedBy = props.accessibilityDescribedBy,
      accessibilityDetails = props.accessibilityDetails,
      accessibilityDisabled = props.accessibilityDisabled,
      accessibilityErrorMessage = props.accessibilityErrorMessage,
      accessibilityExpanded = props.accessibilityExpanded,
      accessibilityFlowTo = props.accessibilityFlowTo,
      accessibilityHasPopup = props.accessibilityHasPopup,
      accessibilityHidden = props.accessibilityHidden,
      accessibilityInvalid = props.accessibilityInvalid,
      accessibilityKeyShortcuts = props.accessibilityKeyShortcuts,
      accessibilityLabel = props.accessibilityLabel,
      accessibilityLabelledBy = props.accessibilityLabelledBy,
      accessibilityLevel = props.accessibilityLevel,
      accessibilityLiveRegion = props.accessibilityLiveRegion,
      accessibilityModal = props.accessibilityModal,
      accessibilityMultiline = props.accessibilityMultiline,
      accessibilityMultiSelectable = props.accessibilityMultiSelectable,
      accessibilityOrientation = props.accessibilityOrientation,
      accessibilityOwns = props.accessibilityOwns,
      accessibilityPlaceholder = props.accessibilityPlaceholder,
      accessibilityPosInSet = props.accessibilityPosInSet,
      accessibilityPressed = props.accessibilityPressed,
      accessibilityReadOnly = props.accessibilityReadOnly,
      accessibilityRequired = props.accessibilityRequired,
      accessibilityRole = props.accessibilityRole,
      accessibilityRoleDescription = props.accessibilityRoleDescription,
      accessibilityRowCount = props.accessibilityRowCount,
      accessibilityRowIndex = props.accessibilityRowIndex,
      accessibilityRowSpan = props.accessibilityRowSpan,
      accessibilitySelected = props.accessibilitySelected,
      accessibilitySetSize = props.accessibilitySetSize,
      accessibilitySort = props.accessibilitySort,
      accessibilityValueMax = props.accessibilityValueMax,
      accessibilityValueMin = props.accessibilityValueMin,
      accessibilityValueNow = props.accessibilityValueNow,
      accessibilityValueText = props.accessibilityValueText,
      classList = props.classList,
      focusable = props.focusable,
      dataSet = props.dataSet,
      nativeID = props.nativeID,
      style = props.style,
      testID = props.testID,
      rest = _objectWithoutPropertiesLoose(props, ["accessibilityActiveDescendant", "accessibilityAtomic", "accessibilityAutoComplete", "accessibilityBusy", "accessibilityChecked", "accessibilityColumnCount", "accessibilityColumnIndex", "accessibilityColumnSpan", "accessibilityControls", "accessibilityDescribedBy", "accessibilityDetails", "accessibilityDisabled", "accessibilityErrorMessage", "accessibilityExpanded", "accessibilityFlowTo", "accessibilityHasPopup", "accessibilityHidden", "accessibilityInvalid", "accessibilityKeyShortcuts", "accessibilityLabel", "accessibilityLabelledBy", "accessibilityLevel", "accessibilityLiveRegion", "accessibilityModal", "accessibilityMultiline", "accessibilityMultiSelectable", "accessibilityOrientation", "accessibilityOwns", "accessibilityPlaceholder", "accessibilityPosInSet", "accessibilityPressed", "accessibilityReadOnly", "accessibilityRequired", "accessibilityRole", "accessibilityRoleDescription", "accessibilityRowCount", "accessibilityRowIndex", "accessibilityRowSpan", "accessibilitySelected", "accessibilitySetSize", "accessibilitySort", "accessibilityValueMax", "accessibilityValueMin", "accessibilityValueNow", "accessibilityValueText", "classList", "focusable", "dataSet", "nativeID", "style", "testID"]);

  var forwardedProps = rest;

  if (accessibilityActiveDescendant) {
    forwardedProps['aria-activedescendant'] = accessibilityActiveDescendant;
  }

  if (accessibilityAtomic) {
    forwardedProps['aria-atomic'] = accessibilityAtomic;
  }

  if (accessibilityAutoComplete) {
    forwardedProps['aria-autocomplete'] = accessibilityAutoComplete;
  }

  if (accessibilityBusy) {
    forwardedProps['aria-busy'] = accessibilityBusy;
  }

  if (accessibilityChecked) {
    forwardedProps['aria-checked'] = accessibilityChecked;
  }

  if (accessibilityColumnCount) {
    forwardedProps['aria-colcount'] = accessibilityColumnCount;
  }

  if (accessibilityColumnIndex) {
    forwardedProps['aria-colindex'] = accessibilityColumnIndex;
  }

  if (accessibilityColumnSpan) {
    forwardedProps['aria-colspan'] = accessibilityColumnSpan;
  }

  if (accessibilityControls) {
    forwardedProps['aria-controls'] = accessibilityControls;
  }

  if (accessibilityDescribedBy) {
    forwardedProps['aria-describedby'] = accessibilityDescribedBy;
  }

  if (accessibilityDetails) {
    forwardedProps['aria-details'] = accessibilityDetails;
  }

  if (accessibilityDisabled === true) {
    forwardedProps['aria-disabled'] = true; // Enhance with native semantics

    if (componentType === 'button' || componentType === 'form' || componentType === 'input' || componentType === 'select' || componentType === 'textarea') {
      forwardedProps.disabled = true;
    }
  }

  if (accessibilityErrorMessage) {
    forwardedProps['aria-errormessage'] = accessibilityErrorMessage;
  }

  if (accessibilityExpanded) {
    forwardedProps['aria-expanded'] = accessibilityExpanded;
  }

  if (accessibilityFlowTo) {
    forwardedProps['aria-flowto'] = accessibilityFlowTo;
  }

  if (accessibilityHasPopup) {
    forwardedProps['aria-haspopup'] = accessibilityHasPopup;
  }

  if (accessibilityHidden) {
    forwardedProps['aria-hidden'] = accessibilityHidden;
  }

  if (accessibilityInvalid) {
    forwardedProps['aria-invalid'] = accessibilityInvalid;
  }

  if (accessibilityKeyShortcuts && Array.isArray(accessibilityKeyShortcuts)) {
    forwardedProps['aria-keyshortcuts'] = accessibilityKeyShortcuts.join(' ');
  }

  if (accessibilityLabel) {
    forwardedProps['aria-label'] = accessibilityLabel;
  }

  if (accessibilityLabelledBy) {
    forwardedProps['aria-labelledby'] = accessibilityLabelledBy;
  }

  if (accessibilityLevel) {
    forwardedProps['aria-level'] = accessibilityLevel;
  }

  if (accessibilityLiveRegion) {
    forwardedProps['aria-live'] = accessibilityLiveRegion;
  }

  if (accessibilityModal) {
    forwardedProps['aria-modal'] = accessibilityModal;
  }

  if (accessibilityMultiline) {
    forwardedProps['aria-multiline'] = accessibilityMultiline;
  }

  if (accessibilityMultiSelectable) {
    forwardedProps['aria-multiselectable'] = accessibilityMultiSelectable;
  }

  if (accessibilityOrientation) {
    forwardedProps['aria-orientation'] = accessibilityOrientation;
  }

  if (accessibilityOwns) {
    forwardedProps['aria-owns'] = accessibilityOwns;
  }

  if (accessibilityPlaceholder) {
    forwardedProps['aria-placeholder'] = accessibilityPlaceholder;
  }

  if (accessibilityPosInSet) {
    forwardedProps['aria-posinset'] = accessibilityPosInSet;
  }

  if (accessibilityPressed) {
    forwardedProps['aria-pressed'] = accessibilityPressed;
  }

  if (accessibilityReadOnly) {
    forwardedProps['aria-readonly'] = accessibilityReadOnly; // Enhance with native semantics

    if (componentType === 'input' || componentType === 'select' || componentType === 'textarea') {
      forwardedProps.readOnly = true;
    }
  }

  if (accessibilityRequired) {
    forwardedProps['aria-required'] = accessibilityRequired; // Enhance with native semantics

    if (componentType === 'input' || componentType === 'select' || componentType === 'textarea') {
      forwardedProps.required = true;
    }
  }

  if (accessibilityRole) {
    forwardedProps['role'] = accessibilityRole === 'image' ? 'img' : accessibilityRole;
  }

  if (accessibilityRoleDescription) {
    forwardedProps['aria-roledescription'] = accessibilityRoleDescription;
  }

  if (accessibilityRowCount) {
    forwardedProps['aria-rowcount'] = accessibilityRowCount;
  }

  if (accessibilityRowIndex) {
    forwardedProps['aria-rowindex'] = accessibilityRowIndex;
  }

  if (accessibilityRowSpan) {
    forwardedProps['aria-rowspan'] = accessibilityRowSpan;
  }

  if (accessibilitySelected) {
    forwardedProps['aria-selected'] = accessibilitySelected;
  }

  if (accessibilitySetSize) {
    forwardedProps['aria-setsize'] = accessibilitySetSize;
  }

  if (accessibilitySort) {
    forwardedProps['aria-sort'] = accessibilitySort;
  }

  if (accessibilityValueMax) {
    forwardedProps['aria-valuemax'] = accessibilityValueMax;
  }

  if (accessibilityValueMin) {
    forwardedProps['aria-valuemin'] = accessibilityValueMin;
  }

  if (accessibilityValueNow) {
    forwardedProps['aria-valuenow'] = accessibilityValueNow;
  }

  if (accessibilityValueText) {
    forwardedProps['aria-valuetext'] = accessibilityValueText;
  } // "dataSet" replaced with "data-*"


  if (dataSet != null) {
    for (var dataProp in dataSet) {
      if (hasOwnProperty.call(dataSet, dataProp)) {
        var dataValue = dataSet[dataProp];

        if (dataValue != null) {
          forwardedProps["data-" + dataProp] = dataValue;
        }
      }
    }
  } // "focusable" replaced with "tabindex" et al


  if (focusable != null) {
    if ( // These native elements are focusable by default
    componentType === 'a' || componentType === 'button' || componentType === 'input' || componentType === 'select' || componentType === 'textarea') {
      if (focusable === false || accessibilityDisabled === true) {
        forwardedProps.tabIndex = '-1';
      } else {
        forwardedProps['data-focusable'] = true;
      }
    } else if ( // These roles are made focusable by default
    accessibilityRole === 'button' || accessibilityRole === 'checkbox' || accessibilityRole === 'link' || accessibilityRole === 'menuitem' || accessibilityRole === 'radio' || accessibilityRole === 'textbox' || accessibilityRole === 'switch') {
      if (focusable !== false) {
        forwardedProps['data-focusable'] = true;
        forwardedProps.tabIndex = '0';
      }
    } else {
      // Everything else must explicitly set the prop
      if (focusable === true) {
        forwardedProps['data-focusable'] = true;
        forwardedProps.tabIndex = '0';
      }
    }
  } // "nativeID" replaced with "id"


  if (nativeID != null) {
    forwardedProps.id = nativeID;
  } // "testID" replaced with "data-testid"


  if (testID != null) {
    forwardedProps['data-testid'] = testID;
  } // "classList" & "style" replaced with native "className" & "style"


  var resolvedStyleProps = _styleResolver.default.resolve(style, classList);

  var className = resolvedStyleProps.className;

  if (className != null && className !== '') {
    forwardedProps.className = className;
  }

  if (resolvedStyleProps.style) {
    forwardedProps.style = resolvedStyleProps.style;
  }

  return forwardedProps;
}