"use strict";

exports.__esModule = true;
exports.afterEach = afterEach;

var _modality = require("../__modules__/modality");

var _ResponderSystem = require("../use-responder-events/ResponderSystem");

/**
 * Copyright (c) Nicolas Gallagher.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 * 
 */

/**
 * After each test run it's necessary to reset the state machines in event
 * trackers, as unit tests may only dispatch partial event sequences (e.g.,
 * a test completes or fails after 'touchstart' is dispatched).
 */
function afterEach() {
  if (process.env.NODE_ENV === 'test') {
    // reset modality tracker
    (0, _modality.testOnly_resetActiveModality)(); // reset the responder system

    (0, _ResponderSystem.terminateResponder)();
  } else {
    console.error('react-gui/test-utils: "afterEach" must only be used in unit tests');
  }
}