"use strict";

exports.__esModule = true;
exports.default = useClickEvents;

var _useEvent = _interopRequireDefault(require("../use-event"));

var _useLayoutEffect = _interopRequireDefault(require("../__modules__/useLayoutEffect"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Copyright (c) Nicolas Gallagher.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 * 
 */

/**
 * useClickEvents implementation
 */
var captureOptions = {
  capture: true
};

function useClickEvents(targetRef, config) {
  var disabled = config.disabled,
      onClick = config.onClick,
      onClickCapture = config.onClickCapture; // Event handles (these events bubble)

  var clickHandle = (0, _useEvent.default)('click');
  var clickCaptureHandle = (0, _useEvent.default)('click', captureOptions);
  (0, _useLayoutEffect.default)(function () {
    var target = targetRef.current;

    if (target != null) {
      clickHandle.setListener(target, !disabled && onClick || null);
      clickCaptureHandle.setListener(target, !disabled && onClickCapture || null);
    }
  }, [disabled, clickHandle, clickCaptureHandle, targetRef, onClick, onClickCapture]);
}

module.exports = exports.default;