"use strict";

exports.__esModule = true;
exports.default = useHover;

var React = _interopRequireWildcard(require("react"));

var _useHoverEvents = _interopRequireDefault(require("../use-hover-events"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var emptyObject = {};
var initialState = {
  isHovered: false,
  x: null,
  y: null
};

function reducer(state, action) {
  switch (action.type) {
    case 'change':
      {
        return _objectSpread({}, state, {
          isHovered: action.value
        });
      }

    case 'update':
      {
        var _action$value = action.value,
            x = _action$value.x,
            y = _action$value.y;
        return _objectSpread({}, state, {
          x: x,
          y: y
        });
      }

    case 'reset':
      {
        return initialState;
      }

    default:
      return state;
  }
}

function useHover(targetRef, config) {
  var _ref = config || emptyObject,
      contain = _ref.contain,
      disabled = _ref.disabled,
      updates = _ref.updates;

  var _React$useReducer = React.useReducer(reducer, initialState),
      gestureState = _React$useReducer[0],
      dispatch = _React$useReducer[1];

  function hoverUpdateHandler(e) {
    dispatch({
      type: 'update',
      value: {
        x: e.x,
        y: e.y
      }
    });
  }

  var hoverEventsConfig = React.useMemo(function () {
    return {
      contain: contain,
      disabled: disabled,
      onHoverChange: function onHoverChange(isHovered) {
        dispatch({
          type: 'change',
          value: isHovered
        });

        if (!isHovered && updates) {
          dispatch({
            type: 'reset'
          });
        }
      },
      onHoverUpdate: updates ? hoverUpdateHandler : null
    };
  }, [contain, disabled, updates]);
  (0, _useHoverEvents.default)(targetRef, hoverEventsConfig);
  return gestureState;
}

module.exports = exports.default;