"use strict";

exports.__esModule = true;
exports.default = useInteractOutside;

var _useEvent = _interopRequireDefault(require("../use-event"));

var _useLayoutEffect = _interopRequireDefault(require("../__modules__/useLayoutEffect"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Copyright (c) Nicolas Gallagher.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 * 
 */
function useInteractOutside(targetRef, config) {
  var disabled = config.disabled,
      onInteractOutside = config.onInteractOutside;
  var clickHandle = (0, _useEvent.default)('click');
  (0, _useLayoutEffect.default)(function () {
    var target = targetRef.current; // Determine if we should trigger an outside click

    var clickListener = function clickListener(e) {
      if (target != null && !target.contains(e.target)) {
        if (onInteractOutside != null) {
          onInteractOutside(e);
        }
      }
    };

    if (target != null) {
      clickHandle.setListener(document, !disabled && clickListener || null);
    }
  }, [clickHandle, disabled, onInteractOutside, targetRef]);
}

module.exports = exports.default;