"use strict";

exports.__esModule = true;
exports.default = useLayout;

var React = _interopRequireWildcard(require("react"));

var _useLayoutEvents = _interopRequireDefault(require("../use-layout-events"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Copyright (c) Nicolas Gallagher.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 * 
 */
var emptyObject = {};

function useLayout(targetRef, config) {
  var _ref = config || emptyObject,
      disabled = _ref.disabled;

  var _React$useState = React.useState({}),
      layout = _React$useState[0],
      setLayout = _React$useState[1];

  var layoutEventsConfig = React.useMemo(function () {
    return {
      disabled: disabled,
      onLayout: function onLayout(e) {
        setLayout(e.nativeEvent.layout);
      }
    };
  }, [disabled, setLayout]);
  (0, _useLayoutEvents.default)(targetRef, layoutEventsConfig);
  return layout;
}

module.exports = exports.default;