/**
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 * 
 * @format
 */

/*
'use strict';

import type { EventHandlers, PressResponderConfig } from './PressResponder';

import * as React from 'react';
import PressResponder from './PressResponder';
import useResponderEvents from '../use-responder-events';

export default function usePressEvents(targetRef: any, config: PressResponderConfig) {
  const pressResponderRef = React.useRef<?PressResponder>(null);
  if (pressResponderRef.current == null) {
    pressResponderRef.current = new PressResponder(config);
  }
  const pressResponder = pressResponderRef.current;

  // Re-configure to use the current node and configuration.
  React.useEffect(() => {
    pressResponder.configure(config);
  }, [config, pressResponder]);

  // Reset the `pressResponder` when cleanup needs to occur. This is
  // a separate effect because we do not want to rest the responder when `config` changes.
  React.useEffect(() => {
    return () => {
      pressResponder.reset();
    };
  }, [pressResponder]);

  React.useDebugValue(config);

  useResponderEvents(targetRef, pressResponder.getEventHandlers());
}
*/
"use strict";